## GstBtEnvelopeASDR GstBtEnvelopeASDR — attack-decay-sustain-release envelope generator |

## Functions

GstBtEnvelopeADSR * | gstbt_envelope_adsr_new ()
void | gstbt_envelope_adsr_setup ()

## Properties

gdouble | attack | Read / Write
gdouble | decay | Read / Write
gdouble | floor-level | Read / Write
guint | length | Read / Write
gdouble | peak-level | Read / Write
gdouble | release | Read / Write
gdouble | sustain-level | Read / Write

## Types and Values

struct | GstBtEnvelopeADSR

## Object Hierarchy

        GObject
        ╰── GInitiallyUnowned
            ╰── GstObject
                ╰── GstControlSource
                    ╰── GstTimedValueControlSource
                        ╰── GstInterpolationControlSource
                            ╰── GstBtEnvelope
                                ╰── GstBtEnvelopeADSR

## Includes

    #include <libgstbuzztrax/envelope-adsr.h>

## Description

Classic attack-decay-sustain-release envelope.

## Functions

### gstbt_envelope_adsr_new ()

    GstBtEnvelopeADSR *
    gstbt_envelope_adsr_new (void);

Create a new instance

#### Returns

the new instance or `NULL` in case of an error

### gstbt_envelope_adsr_setup ()

    void
    gstbt_envelope_adsr_setup (GstBtEnvelopeADSR *self,
                               gint samplerate,
                               GstClockTime ticktime);

Initialize the envelope for a new cycle.

#### Parameters

self | the envelope |
samplerate | the audio sampling rate |
ticktime | clocktime for one tick |

## Types and Values

### struct GstBtEnvelopeADSR

    struct GstBtEnvelopeADSR;

Class instance data.

## Property Details

### The `“attack”` property

      “attack”                   gdouble

Attack of the envelope in seconds.

Flags: Read / Write

Allowed values: [0.001,4]

Default value: 0.1

### The `“decay”` property

      “decay”                    gdouble

Decay of the envelope in seconds.

Flags: Read / Write

Allowed values: [0.001,4]

Default value: 0.5

### The `“floor-level”` property

      “floor-level”              gdouble

Lowest level of the envelope.

Flags: Read / Write

Allowed values: >= 0

Default value: 0

### The `“length”` property

      “length”                   guint

Note length in ticks.

Flags: Read / Write

Allowed values: [1,255]

Default value: 1

### The `“peak-level”` property

      “peak-level”               gdouble

Highest level of envelope.

Flags: Read / Write

Allowed values: >= 0

Default value: 1.79769e+308

### The `“release”` property

      “release”                  gdouble

Release of the envelope in seconds.

Flags: Read / Write

Allowed values: [0.001,4]

Default value: 0.5

### The `“sustain-level”` property

      “sustain-level”            gdouble

Sustain level of envelope.

Flags: Read / Write

Allowed values: >= 0

Default value: 8.98847e+307